#pragma GCC optimize("O3")
#pragma GCC target("sse4")

#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>

#define endl '\n'
#define pb push_back
#define fr first
#define sc second
#define ll long long int
#define ld long double
#define bit(idx) (-idx) & (idx)
#define bin(x) bitset<32>(x).to_string()
#define all(A) A.begin(), A.end()
#define de(x) cout << #x << " = " << x << endl;
#define row vector<ll>
#define row_matrix vector<ll>
#define matrix vector<row_matrix>
#define ordered_set_T ll

using namespace std;
using namespace __gnu_pbds;

typedef tree<ordered_set_T, null_type, less<ordered_set_T>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
/// find_by_order(x) -> x-th element in the set
/// order_of_key(x) ->  how many elements are smaller than x

const ll MOD = 1e9 + 7;
const ll MAXN = 1e6 + 6;

int segmtree[4 * MAXN];

void upd(ll node, ll l, ll r, ll x, ll v){
    if(l == r){
        segmtree[node] = v;
    }
    else{
        ll m = (l + r) / 2;
        if(l <= x && x <= m) upd(2 * node + 0, l + 0, m, x, v);
        else                 upd(2 * node + 1, m + 1, r, x, v);
        segmtree[node] = max(segmtree[2 * node], segmtree[2 * node + 1]);
    }
}

ll qry(ll node, ll l, ll r, ll ql, ll qr){
    if(qr < l || r < ql){
        return 0;
    }
    else if(ql <= l && r <= qr){
        return segmtree[node];
    }
    else{
        ll m = (l + r) / 2;
        ll q1 = qry(2 * node + 0, l + 0, m, ql, qr);
        ll q2 = qry(2 * node + 1, m + 1, r, ql, qr);
        return max(q1, q2);
    }
}

void upd(ll x, ll v){ upd(1, 1, MAXN, x, v); }
ll qry(ll l, ll r){ return qry(1, 1, MAXN, l, r); }

int main(){
    ios_base::sync_with_stdio(false); cin.tie(NULL);
    ll n, last = 0, sum = 0, so_far = 0; cin >> n;
    row A(n + 1), answers(n + 1);
    vector<pair<pair<int, bool>, int>> queries;
    for(int i = 1; i <= n; i ++) cin >> A[i];
    for(int i = 1; i <= n; i ++){
        queries.pb({{i, true}, A[i]});
    }
    int q; cin >> q;
    for(int i = 0; i < q; i ++){
        int x, v; cin >> x >> v;
        queries.pb({{x + 1, false}, v});
    }
    sort(all(queries));
    upd(0, 0);
    for(auto [query, x] : queries){
        int pos = query.fr;
        bool flag = query.sc;
        ll curr = 0;
        if(x >= last){
            curr = (answers[pos - 1] + x) % MOD;
        }
        if(x < last){
            ll j = qry(1, x);
            curr = (answers[j] + ((pos - j) * x) % MOD) % MOD;
        }
        sum = (sum + curr) % MOD;
        if(flag){
            upd(x, pos);
            last = x;
            answers[pos] = curr;
            so_far = (so_far + curr) % MOD;
        }
        else{
            sum = (sum + so_far) % MOD;
        }
    }
    cout << sum << endl;
}
