#include <algorithm>
#include <iostream>
#include <vector>
#include <queue>
#define endl '\n'
using namespace std;

const int MAX = 20000;
const int MAXK = 100;

int n[MAX + 5];
bool used[MAX + 5];
vector<int> G[MAX + 5];
long double idx[MAX + 5];
int num[MAX + 5][MAXK + 5];

void BFS(int u)
{
    queue<int> q;
    q.push(u);
    idx[u] = 0.0;
    used[u] = true;
    while (!q.empty())
    {
        u = q.front();
        q.pop();

        for (int j = 0; j < G[u].size(); ++ j)
        {
            int s = G[u][j];
            vector<int> v;
            for (int t = 1; t <= n[s]; ++ t)
            {
                if (used[num[s][t]])
                {
                    v.push_back(t);
                }
            }

            int sz = v.size();

            for (int t = 1; t < v[0]; ++ t)
            {
                if (!used[num[s][t]])
                {
                    idx[num[s][t]] = v[0];
                    q.push(num[s][t]);
                    used[num[s][t]] = true;
                }
            }

            for (int t = v[sz - 1] + 1; t <= n[s]; ++ t)
            {
                if (!used[num[s][t]])
                {
                    idx[num[s][t]] = v[sz - 1];
                    q.push(num[s][t]);
                    used[num[s][t]] = true;
                }
            }

            for (int t = 0; t < sz - 1; ++ t)
            {
                long double st = idx[num[s][v[t]]];
                long double en = idx[num[s][v[t + 1]]];

                long double add = 1.0 * (en - st) / (v[t + 1] - v[t]);
                if (add < 0.0)
                {
                    cout << 0 << endl;
                    exit(0);
                }

                for (int r = v[t] + 1; r < v[t + 1]; ++ r)
                {
                    st += add;
                    idx[num[s][r]] = st;
                    q.push(num[s][r]);
                    used[num[s][r]] = true;
                }
            }
        }
    }
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int k;
    cin >> k;

    for (int i = 1; i <= k; ++ i)
    {
        cin >> n[i];

        for (int j = 1; j <= n[i]; ++ j)
        {
            cin >> num[i][j];
            G[num[i][j]].push_back(i);
        }
    }

    for (int i = 1; i <= MAX; ++ i)
    {
        if (!used[i])
        {
            BFS(i);
        }
    }

    cout << 1 << endl;

    return 0;
}
