#include <iostream>
#include <algorithm>
#include <stack>
using namespace std;

const int MAXN = 1048576;
const long long MOD = 1000000007;

long long st[MAXN];

int n, q;

struct qry
{
    int ind;
    int val;

    bool operator < (qry A) const
    {
        return ind < A.ind;
    }

};
qry allq[MAXN];
int currq;


long long a[MAXN];
long long measure[MAXN];

int stsize;
long long stsum[MAXN];

void regul(long long &r)
{
    long long m = MOD << 10;
    r += m;
    r = r % MOD;
}

void pop()
{
    stsize--;
    /*if(stsize > 0) stsum -= a[st[stsize]]*(st[stsize]-st[stsize-1]);
    else stsum -= a[st[stsize]]*(st[stsize]+1);
    regul(stsum);*/
}

long long top()
{
    return a[st[stsize-1]];
}

void push(long long curr)
{
    st[stsize] = curr;
    if(stsize > 0) stsum[stsize] = stsum[stsize-1] + a[curr]*(curr-st[stsize-1]);
    else stsum[stsize] = a[curr]*(curr+1);
    regul(stsum[stsize]);
    stsize++;
}


long long ans;

void addtoans(int li, int val)
{
    if(li == 0){
        ans += val;
        regul(ans);
        return;
    }
    if(val <= a[st[0]]){
        ans += measure[li-1] + val*(li+1);
        regul(ans);
        return;
    }
    int l = 0, r = stsize;
    while(l != r){
        int m = (l+r+1)/2;
        if(m == stsize){
            r = m-1;
        }
        if(a[st[m]] < val){
            l = m;
        }
        if(a[st[m]] >= val){
            r = m-1;
        }
    }
    ans += measure[li-1] + stsum[l] + val*(li-st[l]);
    regul(ans);
    return;
}

int main(){

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n;
    for(int i = 0; i < n; i++){
        cin >> a[i];
    }
    cin >> q;
    for(int i = 0; i < q; i++){
        cin >> allq[i].ind >> allq[i].val;
    }

    sort(allq, allq+q);

    for(int i = 0; i < n; i++){

        if(currq < q && allq[currq].ind == i){
            addtoans(i, allq[currq].val);
            currq++;
            i--;
            continue;
        }

        while(stsize > 0 && a[i] <= top()){
            pop();
        }
        push(i);
        if(i > 0) measure[i] = measure[i-1]+stsum[stsize-1];
        else measure[i] = stsum[stsize-1];
        regul(measure[i]);
    }


    ans += measure[n-1];
    regul(ans);
    cout << ans << endl;

    return 0;
}
