#include <iostream>
#include <vector>
using namespace std;

const int MAXN = 1048576;

bool isPrime[MAXN];
vector<int> primes;
long long pref[83000];

void fillPrimes(int maximal)
{
    for(int z = 2; z <= maximal; z++){
        if(!isPrime[z]){
            primes.push_back(z);
            pref[primes.size()] = pref[primes.size()-1] + (long long)z;
            for(int k = 2; k*z <= maximal; k++){
                isPrime[k*z] = true;
            }
        }
    }
}

int a, b;

struct Ford
{
    int p;
    long long length;
    int start, finish;
};

Ford ans, currFound;

Ford findAns(int primeInd)
{
    int p = primes[primeInd];
    int l = 0, r = 1;
    while(pref[r] - pref[l] != p){
        if(pref[r] - pref[l] < p){
            r++;
        }
        else{
            l++;
        }
    }
    Ford tbr; //to be returned
    tbr.p = p; tbr.length = r-l; tbr.start = l; tbr.finish = r;
    //if(pref[r] - pref[l])
    return tbr;
}

int main(){

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> a >> b;

    fillPrimes(b);

    int firstInInterval = 0;
    while(primes.size() > firstInInterval && primes[firstInInterval] < a) firstInInterval++;
    if(firstInInterval >= primes.size() || primes[firstInInterval] > b){
        cout << "no primes" << endl;
        return 0;
    }

    ans.length = -1;

    for(int i = firstInInterval; primes[i] <= b; i++){
        currFound = findAns(i);
        if(currFound.length > ans.length){
            ans = currFound;
        }
    }

    cout << ans.p << " " << ans.length << endl;
    for(int i = ans.start; i < ans.finish; i++){
        cout << primes[i] << " ";
    }
    cout << endl;

return 0;
}

