#include<iostream>
#include<vector>

#define endl '\n'

using namespace std;

const int MAXN=1e7+3;
int fenwick[MAXN];

void update_tree(int ind, int val){
    while(ind<MAXN){
        fenwick[ind]+=val;
        ind+=(ind & (-ind));
    }
}

int sum_tree(int ind){
    int res=0;
    while(ind>0){
        res+=fenwick[ind];
        ind-=(ind & (-ind));
    }
    return res;
}

vector<int> merge_sort(int l, int r, vector<int>& nums, bool& is_inversion){
    if(l==r){
        return {nums[l]};
    }

    int mid=(l+r)/2;
    vector<int> half1=merge_sort(l, mid, nums, is_inversion);
    vector<int> half2=merge_sort(mid+1, r, nums, is_inversion);

    int i=0,n=(int)half1.size();
    int j=0,m=(int)half2.size();

    vector<int> res;
    while(i<n and j<m){
        if(half1[i]>half2[j]){
            is_inversion=true;
            res.push_back(half2[j++]);
        }else{
            res.push_back(half1[i++]);
        }
    }

    while(i<n){
        res.push_back(half1[i++]);
    }
    while(j<m){
        res.push_back(half2[j++]);
    }

    return res;
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int k;
    cin>>k;

    vector<int> pos(MAXN, -1);
    int free_pos=1;

    bool check_recostruction=true;
    for(int i=0;i<k;++i){
        int n;
        cin>>n;

        vector<int> machines(n);
        int first_added=-1,last_added=-1;

        for(int i=0;i<n;++i){
            cin>>machines[i];

            if(pos[machines[i]]==-1){
                if(first_added==-1){
                    first_added=free_pos;
                }
                last_added=free_pos;

                pos[machines[i]]=free_pos++;
            }else if(first_added!=-1){
                int bonus=last_added-pos[machines[i]]+1;

                update_tree(pos[machines[i]], bonus);
                update_tree(first_added, -bonus);

                free_pos=first_added+bonus;
                first_added=last_added=-1;
            }
        }

        for(int i=0;i<n;++i){
            // cout<<"pos: "<<i<<" "<<pos[machines[i]]<<" "<<sum_tree(pos[machines[i]])<<endl;
            machines[i]=pos[machines[i]]+sum_tree(pos[machines[i]]);
        }

        /*cout<<"machines: ";
        for(int curr : machines){
            cout<<curr<<" ";
        }
        cout<<endl;*/

        bool is_inversion=false;
        merge_sort(0, n-1, machines, is_inversion);

        check_recostruction&=(!is_inversion);
    }

    cout<<check_recostruction<<endl;
return 0;
}
