#include <stdio.h>
#include <stdint.h>

#define eprintf(...) fprintf(stderr, __VA_ARGS__)

#define MAX_K 200
#define MAX_N 40000

struct Edge {
    int to;
    Edge *next;
};

Edge *edges_head[MAX_N];
Edge edges[MAX_N * MAX_K];
int edges_size;
int ans;

#define NOT_VISITED 0
#define IN_STACK 1
#define VISITED 2
uint8_t state[MAX_N];
int line[MAX_N];

void make_edge(int from, int to) {
    edges[edges_size].to = to;
    edges[edges_size].next = edges_head[from];
    edges_head[from] = &edges[edges_size];
    edges_size++;
}

void dfs(int root) {
    if (state[root] == VISITED) return;
    if (state[root] == IN_STACK) {
        ans = 0;
        return;
    }
    state[root] = IN_STACK;
    Edge *e = edges_head[root];
    while (e) {
        dfs(e->to);
        e = e->next;
    }
    state[root] = VISITED;
}

int main() {
    setvbuf(stdin, NULL, _IOFBF, 4096);
    setvbuf(stdout, NULL, _IOFBF, 4096);
    setbuf(stderr, NULL);

    for (int t = 0; t < 5; ++t) {
        for (int i = 0; i < MAX_N; ++i) edges_head[i] = NULL;
        for (int i = 0; i < MAX_N; ++i) state[i] = NOT_VISITED;
        edges_size = 0;
        ans = 1;
        int k;
        scanf("%d", &k);
        for(int i = 0; i < k; ++i) {
            int n;
            scanf("%d", &n);
            for (int j = 0; j < n; ++j) scanf("%d", &line[j]);
            for (int j = 0; j < n - 1; ++j) make_edge(line[j] - 1, line[j + 1] - 1);
        }
        for (int i = 0; i < MAX_N; ++i) dfs(i);
        printf("%d\n", ans);
    }
}
