#include <stdio.h>
#include <stdint.h>

#define IO_BUFFER_SIZE 4096
#define eprintf(...) fprintf(stderr, __VA_ARGS__)

#define MAX_N 1000000

struct Node {
    int64_t index;
    int64_t val;
};

int64_t n;
Node tree[MAX_N * 4];
Node big_node = {-1, 1000000};
int64_t arr[MAX_N];

void set_util(int64_t root, int64_t root_l, int64_t root_r, int64_t index, int64_t val) {
    if (root_r <= index) return;
    if (index < root_l) return;
    if (root_l == index && root_l == root_r - 1) {
        tree[root].index = index;
        tree[root].val = val;
        return;
    }
    int64_t root_m = (root_l + root_r) / 2;
    set_util(root * 2, root_l, root_m, index, val);
    set_util(root * 2 + 1, root_m, root_r, index, val);
    if (tree[root*2].val < tree[root*2+1].val) tree[root] = tree[root*2];
    else tree[root] = tree[root*2+1];
}
#define set(index, val) set_util(1, 0, n, index, val)

void print64_t_min(int64_t root, int64_t root_l, int64_t root_r) {
    printf("min[%d;%d) = [%d] = %d\n", root_l, root_r, tree[root].index, tree[root].val);
    if (root_l == root_r - 1) return;
    int64_t root_m = (root_l + root_r) / 2;
    print_min(root * 2, root_l, root_m);
    print_min(root * 2 + 1, root_m, root_r);
}

Node find_min_util(int64_t root, int64_t root_l, int64_t root_r, int64_t query_l, int64_t query_r) {
    if (query_r <= root_l) return  big_node;
    if (root_r <= query_l) return big_node;
    if (query_l <= root_l && root_r <= query_r) return tree[root];
    int64_t root_m = (root_l + root_r) / 2;
    Node node_l = find_min_util(root * 2, root_l, root_m, query_l, query_r);
    Node node_r = find_min_util(root * 2 + 1, root_m, root_r, query_l, query_r);
    return node_l.val < node_r.val ? node_l : node_r;
}
#define find_min(query_l, query_r) find_min_util(1, 0, n, query_l, query_r)

int64_t measure(int64_t query_l, int64_t query_r) {
    if (query_l > query_r - 1) return 0;
    Node min = find_min(query_l, query_r);
    if (query_l == query_r - 1) min.val;
    int64_t size_l = min.index - query_l + 1;
    int64_t size_r = query_r - min.index;
    return measure(query_l, min.index) + measure(min.index + 1, query_r) + size_l * size_r * min.val;
}

int main() {
    setvbuf(stdin, NULL, _IOFBF, IO_BUFFER_SIZE);
    setvbuf(stdout, NULL, _IOFBF, IO_BUFFER_SIZE);
    setbuf(stderr, NULL);

    scanf("%lld", &n);
    for (int64_t i = 0; i < n; ++i) {
        scanf("%lld", &arr[i]);
        set(i, arr[i]);
    }
    int64_t ans = measure(0, n);
    //printf("%lld\n", measure(0, n));
    int64_t q;
    scanf("%d", &q);
    for (int64_t i = 0; i < q; ++i) {
        int64_t index, val;
        scanf("%lld%lld", &index, &val);
        set(index, val);
        ans += measure(0, index + 1);
        ans %= 1000000007;
        //printf("%lld\n", measure(0, index + 1));
        set(index, arr[index]);
    }
    printf("%lld\n", ans);
}
/*
5
4 7 5 2 3
3
4 2
2 1
0 8
*/
