#include <stdio.h>
#include <stdint.h>

#define IO_BUFFER_SIZE 4096
#define eprintf(...) fprintf(stderr, __VA_ARGS__)

typedef int_fast8_t  s8;
typedef int_fast16_t s16;
typedef int_fast32_t s32;
typedef int_fast64_t s64;

typedef uint_fast8_t  u8;
typedef uint_fast16_t u16;
typedef uint_fast32_t u32;
typedef uint_fast64_t u64;

u8 is_composite[1000000];
u32 primes_size = 0;
u64 primes[1000000];
u64 prefix[1000000];

int main() {
    setvbuf(stdin, NULL, _IOFBF, IO_BUFFER_SIZE);
    setvbuf(stdout, NULL, _IOFBF, IO_BUFFER_SIZE);
    setbuf(stderr, NULL);

    is_composite[0] = is_composite[1] = 1;
    for (u32 i = 2; i < 1000000; ++i) {
        if (is_composite[i]) continue;
        for (u32 j = i + i; j < 1000000; j += i) is_composite[j] = 1;
        ++primes_size;
    }
    for (u32 i = 0; i < 1000000; ++i) if (!is_composite[i]) primes[primes_size++] = i;
    prefix[0] = primes[0];
    for (int i = 1; i < primes_size; ++i) prefix[i] = primes[i] + prefix[i-1];

    int l, r;
    scanf("%d%d", &l, &r);
    r++;
    for (int i = l; i < r; ++i) {
        if (!is_composite[i]) {
            printf("%d 1\n%d\n", i, i);
            return 0;
        }
    }
    printf("no prime\n");
}
