#include<iostream>
#include<vector>
using namespace std;

const int MAXN=20001;
vector<int> nodes[MAXN];
int incomingEdges[MAXN];

bool visited[MAXN];
bool added[MAXN];

bool possible=false;

void DFS(int index)
{
    //cout << index << endl;

    visited[index]=true;

    int ns=nodes[index].size();
    for(int i=0; i<ns; i++)
    {
        //cout << " = " << nodes[index][i] << endl;

        if(visited[nodes[index][i]])
        {
            if(added[nodes[index][i]])
            {
                continue;
            }

            possible=false;
            return;
        }

        DFS(nodes[index][i]);

        if(!possible)
        {
            return;
        }
    }

        //cout << " - " << index << endl;

    added[index]=true;

    return;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    for(int i=0; i<MAXN; i++)
    {
        visited[i]=true;
        added[i]=true;
        incomingEdges[i]=0;
    }

    int k;
    cin >> k;

    while(k>0)
    {
        int n;
        cin >> n;

        int previous;
        cin >> previous;

        visited[previous]=false;
        added[previous]=false;

        while(n>1)
        {
            int node;
            cin >> node;

            incomingEdges[node]++;
            visited[node]=false;
            added[node]=false;

            //cout << previous << "->" << node << endl;
            nodes[previous].push_back(node);

            previous=node;

            n--;
        }

        k--;
    }

    for(int i=0; i<MAXN; i++)
    {
        if(incomingEdges[i]==0 && !visited[i])
        {
            possible=true;
            DFS(i);

            if(!possible)
            {
                break;
            }
        }
    }

    if(possible)
    {
        cout << "1\n";
    }
    else
    {
        cout << "0\n";
    }

    return 0;
}

