#include<iostream>
#include<queue>
using namespace std;

const int MOD=1e9+7;

const int MAXN=1e6;
int numbers[MAXN];

struct number
{
    int minLeftIndex;
    int minRightIndex;
};

number minLeftRight[MAXN];

priority_queue<pair<int, int> > q;

long long getCombinations(int l, int r, int index)
{
    long long result=0;

    while(l<=r && l<=index)
    {
        result=(result+r-index+1)%MOD;

        l++;
    }

    return result%MOD;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    int n;
    cin >> n;

    for(int i=0; i<n; i++)
    {
        cin >> numbers[i];
    }

    int testsCount;
    cin >> testsCount;

    for(int i=0; i<n; i++)
    {
        while(!q.empty() && q.top().first>numbers[i])
        {
            //cout << q.top().first << " " << q.top().second << endl;

            minLeftRight[q.top().second].minRightIndex=i;
            q.pop();
        }

        q.push(make_pair(numbers[i], i));
    }

    while(!q.empty())
    {
        minLeftRight[q.top().second].minRightIndex=n;
        q.pop();
    }

    for(int i=n-1; i>=0; i--)
    {
        while(!q.empty() && q.top().first>=numbers[i])
        {
            //cout << q.top().first << " " << q.top().second << endl;

            minLeftRight[q.top().second].minLeftIndex=i;
            q.pop();
        }

        q.push(make_pair(numbers[i], i));
    }

    while(!q.empty())
    {
        minLeftRight[q.top().second].minLeftIndex=-1;
        q.pop();
    }

    long long result=0;
    for(int i=0; i<n; i++)
    {
        //cout << i << " " << getCombinations(minLeftRight[i].minLeftIndex+1, minLeftRight[i].minRightIndex-1, i) << endl;
        result=(result+((getCombinations(minLeftRight[i].minLeftIndex+1, minLeftRight[i].minRightIndex-1, i)*numbers[i])%MOD))%MOD;
    }

    while(testsCount>0)
    {
        int ind, value;
        cin >> ind >> value;

        int previous=numbers[ind];
        numbers[ind]=value;

        n=ind+1;

         for(int i=0; i<n; i++)
            {
                while(!q.empty() && q.top().first>numbers[i])
                {
                    //cout << q.top().first << " " << q.top().second << endl;

                    minLeftRight[q.top().second].minRightIndex=i;
                    q.pop();
                }

                q.push(make_pair(numbers[i], i));
            }

            while(!q.empty())
            {
                minLeftRight[q.top().second].minRightIndex=n;
                q.pop();
            }

            for(int i=n-1; i>=0; i--)
            {
                while(!q.empty() && q.top().first>=numbers[i])
                {
                    //cout << q.top().first << " " << q.top().second << endl;

                    minLeftRight[q.top().second].minLeftIndex=i;
                    q.pop();
                }

                q.push(make_pair(numbers[i], i));
            }

            while(!q.empty())
            {
                minLeftRight[q.top().second].minLeftIndex=-1;
                q.pop();
            }

            for(int i=0; i<n; i++)
            {
                //cout << i << " " << getCombinations(minLeftRight[i].minLeftIndex+1, minLeftRight[i].minRightIndex-1, i) << endl;
                result=(result+((getCombinations(minLeftRight[i].minLeftIndex+1, minLeftRight[i].minRightIndex-1, i)*numbers[i])%MOD))%MOD;
            }

        numbers[ind]=previous;

        testsCount--;
    }

    cout << result << "\n";

    return 0;
}
/*
3
4 7 1
0
*/
