#include<iostream>
#include<vector>
#include<stack>
using namespace std;

const int MAXB=1000000;
bool sieve[MAXB];

vector<int> primes;

void getPrimes(int b)
{
    for(int i=0; i<=b; i++)
    {
        sieve[i]=true;
    }
    sieve[0]=false;
    sieve[1]=false;

    for(int i=2; i<=b; i++)
    {
        if(!sieve[i])
        {
            continue;
        }

        primes.push_back(i);

        for(int j=i*i; j>0 && j<=b; j+=i)
        {
            sieve[j]=false;
        }
    }

    return;
}

vector<pair<int, int> > chains[MAXB];

stack<int> result;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    int a, b;
    cin >> a >> b;

    getPrimes(b);

    int ps=primes.size(), primeIndex=0;
    int maxLength=-1, lastPrime=-1;
    for(int i=0; i<=b; i++)
    {
        if(!sieve[i] && chains[i].size()==0)
        {
            continue;
        }

        if(sieve[i])
        {
            chains[i].push_back(make_pair(primeIndex, 1));

            primeIndex++;
        }

        int cs=chains[i].size();
        for(int j=0; j<cs; j++)
        {
            if(i>=a && sieve[i] && maxLength<chains[i][j].second)
            {
                maxLength=chains[i][j].second;
                lastPrime=chains[i][j].first;
            }

            if(chains[i][j].first+1<ps && i+primes[chains[i][j].first+1]<=b)
            {
                //cout << "-=-" << i+primes[chains[i].lastIndex+1] << endl;

                chains[i+primes[chains[i][j].first+1]].push_back(make_pair(chains[i][j].first+1, chains[i][j].second+1));
            }
        }
    }

    if(maxLength==-1)
    {
        cout << "no prime\n";
    }
    else
    {
        int chainSum=0;
        for(int i=0; i<maxLength; i++)
        {
            result.push(primes[lastPrime]);
            chainSum+=primes[lastPrime];
            lastPrime--;
        }

        cout << chainSum << " " << maxLength << "\n";

        while(!result.empty())
        {
            cout << result.top() << " ";
            result.pop();
        }

        cout << "\n";
    }

    return 0;
}
