#include<iostream>
#include<vector>
#include<stack>
using namespace std;

const int MAXB=1000000;
bool sieve[MAXB];

vector<int> primes;

void getPrimes(int b)
{
    for(int i=0; i<=b; i++)
    {
        sieve[i]=true;
    }
    sieve[0]=false;
    sieve[1]=false;

    for(int i=2; i<=b; i++)
    {
        if(!sieve[i])
        {
            continue;
        }

        primes.push_back(i);

        for(int j=i*i; j>0 && j<=b; j+=i)
        {
            sieve[j]=false;
        }
    }

    return;
}

pair<int, int> maxLength[MAXB];

stack<int> result;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    int a, b;
    cin >> a >> b;

    getPrimes(b);

    for(int i=0; i<=b; i++)
    {
        maxLength[i].first=0;
        maxLength[i].second=0;
    }

    int ps=primes.size();
    int maxIndex=-1;
    for(int i=0; i<ps; i++)
    {
        if(maxIndex>=0 && ps-i<maxLength[maxIndex].first)
        {
            break;
        }

        int currentPrime=i;
        int currentSum=primes[i], currentLength=1;
        while(currentSum<=b)
        {
            if(currentSum>=a && sieve[currentSum] && (maxIndex==-1 || maxLength[maxIndex].first<currentLength))
            {
                maxLength[currentSum].first=currentLength;
                maxLength[currentSum].second=currentPrime;

                maxIndex=currentSum;
            }

            currentPrime++;
            if(currentPrime>=ps)
            {
                break;
            }

            currentSum+=primes[currentPrime];
            currentLength++;
        }

        if(maxIndex==currentSum || maxIndex==currentSum-primes[currentPrime])
        {
            break;
        }
    }

    if(maxIndex==-1)
    {
        cout << "no prime\n";
    }
    else
    {
        int chainSum=0, lastPrime=maxLength[maxIndex].second;
        for(int i=0; i<maxLength[maxIndex].first; i++)
        {
            result.push(primes[lastPrime]);
            chainSum+=primes[lastPrime];
            lastPrime--;
        }

        cout << chainSum << " " << maxLength[maxIndex].first << "\n";

        while(!result.empty())
        {
            cout << result.top() << " ";
            result.pop();
        }

        cout << "\n";
    }

    return 0;
}
