#include<iostream>
#include<vector>
#include<stack>
using namespace std;

const int MAXB=1000000;
bool sieve[MAXB];

vector<int> primes;

void getPrimes(int b)
{
    for(int i=0; i<=b; i++)
    {
        sieve[i]=true;
    }
    sieve[0]=false;
    sieve[1]=false;

    for(int i=2; i<=b; i++)
    {
        if(!sieve[i])
        {
            continue;
        }

        primes.push_back(i);

        for(int j=i*i; j>0 && j<=b; j+=i)
        {
            sieve[j]=false;
        }
    }

    return;
}

struct chain
{
    int lastIndex;
    int length;
};

chain chains[MAXB];

stack<int> result;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    int a, b;
    cin >> a >> b;

    getPrimes(b);

    for(int i=0; i<=b; i++)
    {
        chains[i].lastIndex=-1;
        chains[i].length=0;
    }

    int ps=primes.size(), primeIndex=0;
    int maxLength=-1, chainSum=-1;
    for(int i=0; i<=b; i++)
    {
        if(!sieve[i] && chains[i].lastIndex==-1)
        {
            continue;
        }

        if(sieve[i] && chains[i].lastIndex==-1)
        {
            chains[i].lastIndex=primeIndex;
            chains[i].length=1;

            primeIndex++;
        }

        if(i>=a && sieve[i] && maxLength<chains[i].length)
        {
            maxLength=chains[i].length;
            chainSum=i;
        }

        if(chains[i].lastIndex+1<ps && i+primes[chains[i].lastIndex+1]<=b)
        {

            chains[i+primes[chains[i].lastIndex+1]].lastIndex=chains[i].lastIndex+1;
            chains[i+primes[chains[i].lastIndex+1]].length=chains[i].length+1;
        }

    }

    if(maxLength==-1)
    {
        cout << "no prime\n";
    }
    else
    {
        cout << chainSum << " " << maxLength << "\n";

        while(chainSum>0)
        {
            //cout << chainSum << " = " << primes[chains[chainSum].lastIndex] << endl;
            result.push(primes[chains[chainSum].lastIndex]);
            chainSum-=primes[chains[chainSum].lastIndex];
        }

        while(!result.empty())
        {
            cout << result.top() << " ";
            result.pop();
        }

        cout << "\n";
    }

    return 0;
}
